using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;

namespace Redeyes
{
public class DiviningCleavageAndNipples : MVRScript
{
    protected class ItemBreastsAdjustEnabledStruct 
    {
        public string uid;
        public JSONStorableBool jsb;
        
        public ItemBreastsAdjustEnabledStruct(string uid, JSONStorableBool jsb)
        {
            this.uid = uid;
            this.jsb = jsb;
        }
    }

    protected UIDynamicButton btn;
    protected bool isSceneLoaded = false;
    protected bool tmpbool;
    protected struct PersonInfo 
    {
        public Atom PersonAtom;
        public bool IsFemale;
        public bool DoCleavage;
        public DAZMorph Breasts_Hang_Forward, Breasts_Move_S2S_Op, Breasts_TogetherApart, Breasts_Flatten, Breasts_Width, Breasts_Height;
        public DAZMorph V_Redeyes_Nipples;
        public List<JSONStorableBool> _itemEnabledJsbs;// = new List<JSONStorableBool>();
        public List<ItemBreastsAdjustEnabledStruct> ItemBreastsAdjustEnabledJSON;// = new List<ItemBreastsAdjustEnabledStruct>();
        public List<ItemBreastsAdjustEnabledStruct> ItemUndressEnabledJSON;// = new List<ItemBreastsAdjustEnabledStruct>();
    }
    //protected PersonInfo personInfo;
    protected List<PersonInfo> ListOfPersonAtoms = new List<PersonInfo>();

    protected JSONStorableBool NippleReduceEnabledJSON = new JSONStorableBool("Nipple Reduce", true);
    protected JSONStorableBool CleavageMorphEnabledJSON = new JSONStorableBool("Cleavage/Boob Morph squeeze", true);
    protected JSONStorableBool CleavagePhysicsEnabledJSON = new JSONStorableBool("Cleavage/Boob Physics squeeze", true);


    protected JSONStorable js;
    protected DAZCharacterSelector dcs;
    protected GenerateDAZMorphsControlUI morphUI;
    protected JSONStorableFloat Breasts_Hang_Forward_amount, Breasts_Move_S2S_Op_amount, Breasts_TogetherApart_amount, Breasts_Flatten_amount, Breasts_Height_amount, Breasts_Width_amount, morph_speed;// = 2f;
    protected JSONStorableFloat V_Redeyes_Nipples_amount;
    protected JSONStorableFloat femaleBreastAdjustJointsX_amount, femaleBreastAdjustJointsY_amount;

    protected float lastActionTime = 0f;
    protected float actionInterval = 0.25f; 
    protected float count;
    protected bool IsTittyMagicCheck = false;

    protected void syncPersonAtoms()
    {
        if(isSceneLoaded)
        {
            IsTittyMagicCheck = false;
            //SuperController.LogMessage("syncPersonAtoms");
            /*foreach (PersonInfo personInfo in ListOfPersonAtoms)
            {
                count=0f;
                foreach(var tmpjsb in personInfo._itemEnabledJsbs)
                {
                    tmpjsb.setJSONCallbackFunction -= OnToggleItem;
                    count += 1;
                }
                //SuperController.LogMessage("_itemEnabledJsbs count" + count);
                personInfo._itemEnabledJsbs.Clear();
                count=0f;
                foreach(var tmpjsb in personInfo.ItemBreastsAdjustEnabledJSON)
                {
                    tmpjsb.jsb.setJSONCallbackFunction -= OnToggleItem;
                    count += 1;
                }
                //SuperController.LogMessage("ItemBreastsAdjustEnabledJSON count" + count);
                personInfo.ItemBreastsAdjustEnabledJSON.Clear();
            }
            ListOfPersonAtoms.Clear();*/
            cleanup(false);
            
            List<Atom> tmp_ListOfPersonAtoms;
            tmp_ListOfPersonAtoms = SuperController.singleton.GetAtoms().Where(atom => atom.type == "Person").ToList();

            foreach (Atom personAtom in tmp_ListOfPersonAtoms)
            {
                PersonInfo personInfo;
                personInfo.PersonAtom = personAtom;
                personInfo._itemEnabledJsbs = new List<JSONStorableBool>();

                foreach (MVRScript plugin in GetPluginsFromAtom(personAtom))
                {
                    if(plugin.name.Contains("TittyMagic"))
                    {
                        plugin.enabledJSON.setJSONCallbackFunction += OnToggleItem;
                        //SuperController.LogMessage("plugin " + plugin.name);
                        if(plugin.enabledJSON.val)
                        {
                            IsTittyMagicCheck = true;
                        }
                    }
                    //SuperController.LogMessage("plugin " + plugin.enabledJSON.val);
                    
                    //personInfo._itemEnabledJsbs.Add(plugin.enabledJSON);
                }
                personInfo.ItemBreastsAdjustEnabledJSON = new List<ItemBreastsAdjustEnabledStruct>();
                personInfo.ItemUndressEnabledJSON = new List<ItemBreastsAdjustEnabledStruct>();
                if (personAtom.type == "Person")
                {
                    js = personAtom.GetStorableByID("geometry");
                    dcs = js as DAZCharacterSelector;
                    morphUI = dcs.morphsControlUI;
                     if (morphUI.GetMorphByDisplayName("Breasts Hang Forward") == null || morphUI.GetMorphByDisplayName("Breasts Move S2S Op") == null)
                    {
                        personInfo.IsFemale=false;
                        personInfo.DoCleavage = false;
                        personInfo.Breasts_Hang_Forward  = null;
                        personInfo.Breasts_Move_S2S_Op  = null;
                        personInfo.Breasts_TogetherApart = null;
                        personInfo.Breasts_Flatten = null;
                        personInfo.Breasts_Width = null;
                        personInfo.Breasts_Height = null;
                        personInfo.V_Redeyes_Nipples = null;
                    }
                    else
                    {
                        personInfo.IsFemale=true;
                        personInfo.Breasts_Hang_Forward  = morphUI.GetMorphByDisplayName("Breasts Hang Forward");
                        personInfo.Breasts_Move_S2S_Op  = morphUI.GetMorphByDisplayName("Breasts Move S2S Op");
                        personInfo.Breasts_TogetherApart  = morphUI.GetMorphByDisplayName("Breasts TogetherApart");
                        personInfo.Breasts_Flatten  = morphUI.GetMorphByDisplayName("Breasts Flatten");
                        personInfo.Breasts_Width  = morphUI.GetMorphByDisplayName("Breasts Width");
                        personInfo.Breasts_Height  = morphUI.GetMorphByDisplayName("Breasts Height");
                        personInfo.V_Redeyes_Nipples = morphUI.GetMorphByDisplayName("V-Redeyes_Nipples 4 long");

                        var geometry = (DAZCharacterSelector) personAtom.GetStorableByID("geometry");
                        personInfo.DoCleavage = false;
                        foreach(string boolParamName in geometry.GetBoolParamNames())
                        {
                            if(!boolParamName.StartsWith("clothing:"))
                            {
                                continue;
                            }
                            string uid = boolParamName.Replace("clothing:", "");
                            if(uid == "Clothing Creator")
                            {
                                continue;
                            }
                            var jsb = geometry.GetBoolJSONParam(boolParamName);
                            jsb.setJSONCallbackFunction += OnToggleItem;
                            personInfo._itemEnabledJsbs.Add(jsb);
                            var dazItem = geometry.GetClothingItem(uid);
                            

                            if(jsb.val)
                            {
                                ClothSimControl clothControl = dazItem.GetComponentInChildren<ClothSimControl>();
                                //SuperController.LogMessage(" ItemUndressEnabledJSON.Count " + clothControl.clothSettings.BreakEnabled);
                                

                                JSONStorableBool dazItemUndressBool = new JSONStorableBool(uid, clothControl.clothSettings.BreakEnabled);
                                dazItemUndressBool.setJSONCallbackFunction += OnToggleItem;
                                personInfo.ItemUndressEnabledJSON.Add(new ItemBreastsAdjustEnabledStruct(uid, dazItemUndressBool));

                                JSONStorableBool dazItemBool = new JSONStorableBool(uid, dazItem.adjustFemaleBreastJointSpringAndDamper);
                                dazItemBool.setJSONCallbackFunction += OnToggleItem;
                                personInfo.ItemBreastsAdjustEnabledJSON.Add(new ItemBreastsAdjustEnabledStruct(uid, dazItemBool));

                                if(dazItem.adjustFemaleBreastJointSpringAndDamper && !clothControl.clothSettings.BreakEnabled)
                                {
                                    personInfo.DoCleavage = true;
                                }
                            }
                        }
                        //SuperController.LogMessage(personInfo.PersonAtom.name + " ItemBreastsAdjustEnabledJSON.Count " + personInfo.ItemBreastsAdjustEnabledJSON.Count + " _itemEnabledJsbs " + personInfo._itemEnabledJsbs.Count + " personInfo.DoCleavage " + personInfo.DoCleavage);
                    }
                }
                else
                {
                    personInfo.IsFemale = false;
                    personInfo.DoCleavage = false;
                    personInfo.Breasts_Hang_Forward = null;
                    personInfo.Breasts_Move_S2S_Op = null;
                    personInfo.Breasts_TogetherApart = null;
                    personInfo.Breasts_Flatten = null;
                    personInfo.Breasts_Width = null;
                    personInfo.Breasts_Height = null;
                    personInfo.V_Redeyes_Nipples = null;
                }
                ListOfPersonAtoms.Add(personInfo);
            }
            //IsTittyMagic(IsTittyMagicCheck);
        }
    }

    protected void IsTittyMagic(bool isTittyMagic)
    {
        //SuperController.LogMessage("isTittyMagic " + isTittyMagic);
        if(isTittyMagic)
        {
            Breasts_Hang_Forward_amount.val =  0.5f;
            Breasts_Move_S2S_Op_amount.val = 0.5f;
            Breasts_TogetherApart_amount.val =  0.05f;
            Breasts_Flatten_amount.val = 0.2f;
            Breasts_Height_amount.val =  0.2f;
            Breasts_Width_amount.val = 0.2f;
            CleavagePhysicsEnabledJSON.val = false;
            femaleBreastAdjustJointsY_amount.val =  0f;
            femaleBreastAdjustJointsX_amount.val =  0f;
        }
        else
        {
            Breasts_Hang_Forward_amount.val =  0.5f;
            Breasts_Move_S2S_Op_amount.val = 0.0f;
            Breasts_TogetherApart_amount.val =  0.00f;
            Breasts_Flatten_amount.val = 0.25f;
            Breasts_Height_amount.val =  0.2f;
            Breasts_Width_amount.val = 0.2f;
            CleavagePhysicsEnabledJSON.val = true;
            femaleBreastAdjustJointsY_amount.val =  7f;
            femaleBreastAdjustJointsX_amount.val =  2f;
        }
    }

    void OnToggleItem(JSONStorableBool jsb)
    {
        StartCoroutine(DelayedAction());
    }
    
    IEnumerator DelayedAction()
    {
        //SuperController.LogMessage("DelayedAction");
        yield return new WaitForSeconds(0.2f);
        // Perform your action here
        syncPersonAtoms();
    }

    // Create VaM-UI Float slider
    public static JSONStorableFloat SetupSlider(MVRScript script, string format, string label, float defaultValue, float minValue, float maxValue, bool rightSide)
    {
        JSONStorableFloat storable = new JSONStorableFloat(label, defaultValue, minValue, maxValue, true, true);
        storable.storeType = JSONStorableParam.StoreType.Full;
        UIDynamicSlider slidertmp = script.CreateSlider(storable, rightSide);
        slidertmp.valueFormat = format;
        script.RegisterFloat(storable);
        return storable;
    }

    // Create VaM-UI Toggle button
    public static JSONStorableBool SetupToggle(MVRScript script, string label, bool defaultValue, bool rightSide)
    {
        JSONStorableBool storable = new JSONStorableBool(label, defaultValue);
        storable.storeType = JSONStorableParam.StoreType.Full;
        script.CreateToggle(storable, rightSide);
        script.RegisterBool(storable);
        return storable;
    }

    public static List<MVRScript> GetPluginsFromAtom(Atom atom, string pluginTypeFilter = null)
    {
        List<MVRScript> plugins = new List<MVRScript>();

        MVRPluginManager manager = atom.GetStorableByID("PluginManager") as MVRPluginManager;
        if (manager != null)
        {
            foreach (Transform transform in manager.gameObject.transform.Find("Plugins"))
            {
                MVRScript pluginStorable = transform.gameObject.GetComponent<MVRScript>();
                if (pluginStorable != null && (pluginTypeFilter == null || pluginStorable.name.EndsWith(pluginTypeFilter))) plugins.Add(pluginStorable);
            }
        }

        return plugins;
    }

    public override void Init()
    {
        UIDynamicTextField text = null;
        try
        {

            foreach (var storable in SuperController.singleton
                .GetComponentInChildren<MVRPluginManager>()
                .GetComponentsInChildren<MVRScript>()
                .Where(s => s.name.Contains("Redeyes.DiviningCleavageAndNipples")))
            {
                if(containingAtom.type == "CoreControl")
                {
                    SuperController.LogMessage($"Redeyes.DiviningCleavageAndNipples already running as a session plugin - exiting as scene plugin");
                    DestroyImmediate(this);
                    return;
                }
            }

            
            if (containingAtom.type != "CoreControl" && containingAtom.type != "SessionPluginManager")
            {
                SuperController.LogError($"Please load DiviningLipsAndHands as a Session or Scene Plugin, not with a '{containingAtom.type}' atom.");
                DestroyImmediate(this);
                return;
            }

            SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
            SuperController.singleton.onAtomUIDsChangedHandlers += OnAtomUIDsChanged;
            SuperController.singleton.onAtomUIDsWithRigidbodiesChangedHandlers += OnAtomUIDsWithRigidbodiesChanged;
            SuperController.LogMessage("Starting DiviningCleavageAndNipples");


            //Quick buttons
            btn = CreateButton("Defaults settings using TittyMagic",false);
            btn.button.onClick.AddListener(() => { IsTittyMagic(true); });
            JSONStorableAction WithTittyMagic = new JSONStorableAction("Defaults settings using TittyMagic", () => {
                IsTittyMagic(true);
            });
            RegisterAction(WithTittyMagic);

            btn = CreateButton("Defaults settings No TittyMagic",true);
            btn.button.onClick.AddListener(() => { IsTittyMagic(false); });
            JSONStorableAction WithoutTittyMagic = new JSONStorableAction("Defaults settings No TittyMagic", () => {
                IsTittyMagic(false);
            });
            RegisterAction(WithoutTittyMagic);

            CreateSpacer(false).height = 10f;
            CreateSpacer(true).height = 10f;

// MORPH
            CleavageMorphEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(CleavageMorphEnabledJSON);
            CreateToggle(CleavageMorphEnabledJSON, false);

            Breasts_Hang_Forward_amount = SetupSlider(this,"F2", "Breasts Hang Forward", 0.5f, -0.5f, 2f, false);
            Breasts_Move_S2S_Op_amount = SetupSlider(this,"F2", "Breasts Move S2S Op", 0.5f, -0.5f, 2f, false);
            Breasts_TogetherApart_amount = SetupSlider(this,"F2", "Breasts TogetherApartp", 0.05f, -0.5f, 2f, false);
            Breasts_Flatten_amount = SetupSlider(this,"F2", "Breasts Flatten", 0.2f, -0.5f, 2f, false);
            Breasts_Height_amount = SetupSlider(this,"F2", "Breasts Height", 0.2f, -0.5f, 2f, false);
            Breasts_Width_amount = SetupSlider(this,"F2", "Breasts Width", 0.2f, -0.5f, 2f, false);

// Physics
            CleavagePhysicsEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(CleavagePhysicsEnabledJSON);
            CreateToggle(CleavagePhysicsEnabledJSON, true);

            femaleBreastAdjustJointsY_amount = SetupSlider(this,"F2", "Left/Right Angle Target", 5f, 0f, 20f, true);
            femaleBreastAdjustJointsX_amount = SetupSlider(this,"F2", "UP/Down Angle Target", 2f, 0f, 20f, true);

            //CreateSpacer(false).height = 60f;
            CreateSpacer(true).height = 120f;

            NippleReduceEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(NippleReduceEnabledJSON);
            CreateToggle(NippleReduceEnabledJSON, true);

            V_Redeyes_Nipples_amount = SetupSlider(this,"F2", "Nipples Reduce", -0.5f, -3f, 3f, true);

            CreateSpacer(true).height = 55f;
            morph_speed = SetupSlider(this,"F2", "Morph speed", 2f, 0.1f, 10f, true);


            Breasts_Hang_Forward_amount.val =  0.5f;
            Breasts_Move_S2S_Op_amount.val = 0.5f;
            Breasts_TogetherApart_amount.val =  0.05f;
            Breasts_Flatten_amount.val = 0.2f;
            Breasts_Height_amount.val =  0.2f;
            Breasts_Width_amount.val = 0.2f;
            CleavagePhysicsEnabledJSON.val = false;
            femaleBreastAdjustJointsY_amount.val =  0f;
            femaleBreastAdjustJointsX_amount.val =  0f;


            StartCoroutine(WaitForLoadingComplete());
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(Init)}: {e}");
        }
    }

        private IEnumerator WaitForLoadingComplete()
        {
            //SuperController.LogMessage("WaitForLoadingComplete");
            while (SuperController.singleton.isLoading)
            {
                isSceneLoaded = false;
                yield return null;
            }

            while (SuperController.singleton.freezeAnimation)
            {
                isSceneLoaded = false;
                yield return null;
            }

            yield return null;

            isSceneLoaded = true;
            syncPersonAtoms();
        }

        private void OnSceneLoaded()
        {
            try {
                //SuperController.LogMessage("OnSceneLoaded");
                isSceneLoaded=true;
                syncPersonAtoms();
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnSceneLoaded: " + e);
            }
        }

        private void OnAtomUIDsChanged(List<string> atomUIDs)
        {
            try {
                //SuperController.LogMessage("OnAtomUIDsChanged");
                cleanup(false);
                if (!isSceneLoaded) return;
                var sctrl = SuperController.singleton;
                if (sctrl.isLoading) return;

                syncPersonAtoms();
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnAtomUIDsChanged: " + e);
            }
        }

        private void OnAtomUIDsWithRigidbodiesChanged(List<string> atomUIDs)
        {
            try {
                //SuperController.LogMessage("OnAtomUIDsChanged");
                cleanup(false);
                if (!isSceneLoaded) return;
                var sctrl = SuperController.singleton;
                if (sctrl.isLoading) return;

                syncPersonAtoms();
            }
            catch (Exception e) {
                SuperController.LogError("Exception caught in OnAtomUIDsWithRigidbodiesChanged: " + e);
            }
        }


    public void OnEnable()
    {
        try
        {
            //SuperController.LogMessage("OnEnable");
            syncPersonAtoms();
            //SuperController.LogMessage($"{nameof(DiviningCleavageAndNipples)} enabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(OnEnable)}: {e}");
        }
    }

    public void cleanup(bool zeroMorphs)
    {
        //SuperController.LogMessage("cleanup start " + ListOfPersonAtoms.Count);
        foreach (PersonInfo personInfo in ListOfPersonAtoms)
        {
            if (personInfo.PersonAtom.type == "Person")
            {
                //SuperController.LogMessage("cleanup personInfo " + personInfo.PersonAtom.name);
                foreach(var jsb in personInfo._itemEnabledJsbs)
                {
                    jsb.setJSONCallbackFunction -= OnToggleItem;
                    //count += 1;
                }
                //these lines kill the callback for some reason
                //personInfo._itemEnabledJsbs.Clear();
                //SuperController.LogMessage("cleanup _itemEnabledJsbs count" + count);
                //count=0f;
                foreach(var tmpjsb in personInfo.ItemBreastsAdjustEnabledJSON)
                {
                    tmpjsb.jsb.setJSONCallbackFunction -= OnToggleItem;
                    //count += 1;
                }
                //SuperController.LogMessage("cleanup ItemBreastsAdjustEnabledJSON count" + count);
                //these lines kill the callback for some reason
                //personInfo.ItemBreastsAdjustEnabledJSON.Clear();
                if (personInfo.IsFemale && zeroMorphs)
                {
                    personInfo.Breasts_Hang_Forward.morphValue = 0f;
                    personInfo.Breasts_Move_S2S_Op.morphValue = 0f;
                    personInfo.Breasts_TogetherApart.morphValue = 0f;
                    personInfo.Breasts_Flatten.morphValue = 0f;
                    personInfo.Breasts_Width.morphValue = 0f;
                    personInfo.Breasts_Height.morphValue = 0f;
                    personInfo.V_Redeyes_Nipples.morphValue = 0f;
                }
            }
        }
        ListOfPersonAtoms.Clear();
    }

    public void OnDisable()
    {
        try
        {
            cleanup(true);
            //SuperController.LogMessage($"{nameof(DiviningCleavageAndNipples)} disabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(OnDisable)}: {e}");
        }
    }

    public void OnDestroy()
    {
        try
        {
            cleanup(true);
            //SuperController.LogMessage($"{nameof(DiviningCleavageAndNipples)} destroyed");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(OnDestroy)}: {e}");
        }
    }



    // FixedUpdate is called with each physics simulation frame by Unity
    void FixedUpdate()
    {
        try
        {
            if (Time.time - lastActionTime >= actionInterval)
            {
                foreach (PersonInfo personInfo in ListOfPersonAtoms)
                {
                        //SuperController.LogMessage("personInfo " + personInfo.PersonAtom.name);
                        var geometry = (DAZCharacterSelector) personInfo.PersonAtom.GetStorableByID("geometry");
                        for (int i = 0; i < personInfo.ItemBreastsAdjustEnabledJSON.Count; i++)
                        {
                            var dazItem = geometry.GetClothingItem(personInfo.ItemBreastsAdjustEnabledJSON[i].uid); // if you need access to the item itself
                            tmpbool = dazItem.adjustFemaleBreastJointSpringAndDamper;
                            personInfo.ItemBreastsAdjustEnabledJSON[i].jsb.val = tmpbool;
                            
                            ClothSimControl clothControl = dazItem.GetComponentInChildren<ClothSimControl>();
                            //SuperController.LogMessage(" ItemUndressEnabledJSON.Count " + clothControl.clothSettings.BreakEnabled);

                            tmpbool = clothControl.clothSettings.BreakEnabled;
                            personInfo.ItemUndressEnabledJSON[i].jsb.val = tmpbool;

                            //SuperController.LogMessage("personInfo " + personInfo.PersonAtom.name + " tmpbool " + tmpbool);
                        }
                    
                }
                lastActionTime = Time.time;
            }
            foreach (PersonInfo personInfo in ListOfPersonAtoms)
            {
                if(personInfo.IsFemale)
                {
                    var geometry = (DAZCharacterSelector) personInfo.PersonAtom.GetStorableByID("geometry");
                    if(personInfo.DoCleavage)
                    {
                        if(CleavageMorphEnabledJSON.val)
                        {
                            personInfo.Breasts_Hang_Forward.morphValue = Mathf.Lerp(personInfo.Breasts_Hang_Forward.morphValue, Breasts_Hang_Forward_amount.val, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Move_S2S_Op.morphValue = Mathf.Lerp(personInfo.Breasts_Move_S2S_Op.morphValue, Breasts_Move_S2S_Op_amount.val, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_TogetherApart.morphValue = Mathf.Lerp(personInfo.Breasts_TogetherApart.morphValue, Breasts_TogetherApart_amount.val, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Flatten.morphValue = Mathf.Lerp(personInfo.Breasts_Flatten.morphValue, Breasts_Flatten_amount.val, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Width.morphValue = Mathf.Lerp(personInfo.Breasts_Width.morphValue, Breasts_Width_amount.val, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Height.morphValue = Mathf.Lerp(personInfo.Breasts_Height.morphValue, Breasts_Height_amount.val, morph_speed.val * Time.deltaTime);
                        }
                        else
                        {
                            personInfo.Breasts_Hang_Forward.morphValue = Mathf.Lerp(personInfo.Breasts_Hang_Forward.morphValue, 0f, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Move_S2S_Op.morphValue = Mathf.Lerp(personInfo.Breasts_Move_S2S_Op.morphValue, 0f, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_TogetherApart.morphValue = Mathf.Lerp(personInfo.Breasts_TogetherApart.morphValue, 0f, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Flatten.morphValue = Mathf.Lerp(personInfo.Breasts_Flatten.morphValue, 0f, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Width.morphValue = Mathf.Lerp(personInfo.Breasts_Width.morphValue, 0f, morph_speed.val * Time.deltaTime);
                            personInfo.Breasts_Height.morphValue = Mathf.Lerp(personInfo.Breasts_Height.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        }
                    
                        if(CleavagePhysicsEnabledJSON.val)
                        {
                            geometry.femaleBreastAdjustJoints.targetRotationX = Mathf.Lerp(dcs.femaleBreastAdjustJoints.targetRotationX, femaleBreastAdjustJointsX_amount.val, morph_speed.val * Time.deltaTime);
                            geometry.femaleBreastAdjustJoints.targetRotationY = Mathf.Lerp(dcs.femaleBreastAdjustJoints.targetRotationY, femaleBreastAdjustJointsY_amount.val, morph_speed.val * Time.deltaTime);
                        }
                        else
                        {
                            geometry.femaleBreastAdjustJoints.targetRotationX = Mathf.Lerp(geometry.femaleBreastAdjustJoints.targetRotationX, 0f, morph_speed.val * Time.deltaTime);
                            geometry.femaleBreastAdjustJoints.targetRotationY = Mathf.Lerp(geometry.femaleBreastAdjustJoints.targetRotationY, 0f, morph_speed.val * Time.deltaTime);
                        }
                        if(NippleReduceEnabledJSON.val)
                        {
                            personInfo.V_Redeyes_Nipples.morphValue = Mathf.Lerp(personInfo.V_Redeyes_Nipples.morphValue, V_Redeyes_Nipples_amount.val, morph_speed.val * Time.deltaTime);
                        }
                        else
                        {
                            personInfo.V_Redeyes_Nipples.morphValue = Mathf.Lerp(personInfo.V_Redeyes_Nipples.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        }
                    }
                    else
                    {
                        personInfo.Breasts_Hang_Forward.morphValue = Mathf.Lerp(personInfo.Breasts_Hang_Forward.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        personInfo.Breasts_Move_S2S_Op.morphValue = Mathf.Lerp(personInfo.Breasts_Move_S2S_Op.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        personInfo.Breasts_TogetherApart.morphValue = Mathf.Lerp(personInfo.Breasts_TogetherApart.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        personInfo.Breasts_Flatten.morphValue = Mathf.Lerp(personInfo.Breasts_Flatten.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        personInfo.Breasts_Width.morphValue = Mathf.Lerp(personInfo.Breasts_Width.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        personInfo.Breasts_Height.morphValue = Mathf.Lerp(personInfo.Breasts_Height.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        personInfo.V_Redeyes_Nipples.morphValue = Mathf.Lerp(personInfo.V_Redeyes_Nipples.morphValue, 0f, morph_speed.val * Time.deltaTime);
                        geometry.femaleBreastAdjustJoints.targetRotationX = Mathf.Lerp(geometry.femaleBreastAdjustJoints.targetRotationX, 0f, morph_speed.val * Time.deltaTime);
                        geometry.femaleBreastAdjustJoints.targetRotationY = Mathf.Lerp(geometry.femaleBreastAdjustJoints.targetRotationY, 0f, morph_speed.val * Time.deltaTime);
                    }
                }
            }
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningCleavageAndNipples)}.{nameof(FixedUpdate)}: {e}");
        }
    }
}

} // namespace ToumeiHitsuji end
